package com.ibytecode.businesslogic;

import java.util.List;
import java.lang.Short;

import javax.ejb.Stateless;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import com.ibytecode.entity.Actor;

@Stateless
@Named(value = "actorService")
public class ActorBean {
	
	/* public ActorBean() { }*/
	

	@PersistenceContext(unitName = "FirstEJBsProject")
    private EntityManager entityManager;
	
	
	
	private String greeting;
		
	public String getGreeting() {
		return greeting;
	}

	public void setGreeting(String greeting) {
		this.greeting = greeting;
	}

    public void saveActor(Actor actor) {

        entityManager.persist(actor);

    }

    public Actor findActor(Actor actor) {

        Actor p = entityManager.find(Actor.class, actor.getActorId());

        return p;

    }
    
    public ActorBean() { 
    	
    	Actor actor = new Actor();
    	actor.setActorId(new Short("201"));
    	actor = findActor (actor);
    	
        if (actor != null) {
            greeting = "Hello, " + actor.getFirstName() + " " + actor.getLastName() + "!";
        } else {
            greeting = "No such user exists! Use 'emuster' or 'jdoe'";
        }
    }
    

    public List<Actor> retrieveAllActors() {

        String q = "SELECT p from " + Actor.class.getName() + " p";

        Query query = entityManager.createQuery(q);

        List<Actor> actors = query.getResultList();

        return actors;

    }

}
